# HG changeset patch
# User John D
# Date 1479388985 18000
#      Thu Nov 17 08:23:05 2016 -0500
# Node ID 32483451ec70503d53ddeb5c4ac51801286a33a4
# Parent  64063cd35eb2b04834d0f5fb2c1964e0aa017514
of-gsl: addgsl forge package

* src/of-gsl.mk: new file

* Makefile.in: add gsl to octave forge package list

* dist-files.mk: add of-gsl.mk

* index.html: add of-gsl

* src/gsl.mk: update version, checksum for 1.16

diff -r 64063cd35eb2 -r 32483451ec70 Makefile.in
--- a/Makefile.in	Tue Nov 15 20:18:19 2016 -0500
+++ b/Makefile.in	Thu Nov 17 08:23:05 2016 -0500
@@ -443,7 +443,7 @@
 endif
 
 OCTAVE_FORGE_BASE_URL := 'http://sourceforge.net/projects/octave/files/Octave Forge Packages/Individual Package Releases'
-OCTAVE_FORGE_PACKAGES := $(addprefix of-,miscellaneous struct optim specfun general signal communications image io statistics control geometry windows linear-algebra sockets zenity data-smoothing fuzzy-logic-toolkit quaternion fits tsa dicom netcdf ltfat database instrument-control generate_html nurbs strings financial stk splines dataframe lssa queueing ga odepkg interval nan ocs mapping tisean video zeromq sparsersb)
+OCTAVE_FORGE_PACKAGES := $(addprefix of-,miscellaneous struct optim specfun general signal communications image io statistics control geometry windows linear-algebra sockets zenity data-smoothing fuzzy-logic-toolkit quaternion fits tsa dicom netcdf ltfat database instrument-control generate_html nurbs strings financial stk splines dataframe lssa queueing ga odepkg interval nan ocs mapping tisean video zeromq sparsersb gsl)
 # get ALL deps for all of- packages, regardless of whether building the actual forge package in the installer
 OCTAVE_FORGE_DEPS:= $(sort $(foreach p,$(addprefix $(TOP_DIR)/src/,$(addsuffix .mk,$(OCTAVE_FORGE_PACKAGES))),$(shell $(SED) -n 's/.*_DEPS.*:=\(.*\)/\1/p' $p)))
 
diff -r 64063cd35eb2 -r 32483451ec70 dist-files.mk
--- a/dist-files.mk	Tue Nov 15 20:18:19 2016 -0500
+++ b/dist-files.mk	Thu Nov 17 08:23:05 2016 -0500
@@ -462,6 +462,7 @@
   of-general.mk \
   of-generate_html.mk \
   of-geometry.mk \
+  of-gsl.mk \
   of-image.mk \
   of-interval.mk \
   of-instrument-control.mk \
diff -r 64063cd35eb2 -r 32483451ec70 index.html
--- a/index.html	Tue Nov 15 20:18:19 2016 -0500
+++ b/index.html	Thu Nov 17 08:23:05 2016 -0500
@@ -1918,6 +1918,10 @@
         <td class="website"><a href="http://octave.sf.net/">Octave Forge geometry package</a></td>
     </tr>
     <tr>
+        <td class="package">of-gsl</td>
+        <td class="website"><a href="http://octave.sf.net/">Octave Forge gsl package</a></td>
+    </tr>
+    <tr>
         <td class="package">of-image</td>
         <td class="website"><a href="http://octave.sf.net/">Octave Forge image package</a></td>
     </tr>
diff -r 64063cd35eb2 -r 32483451ec70 src/gsl.mk
--- a/src/gsl.mk	Tue Nov 15 20:18:19 2016 -0500
+++ b/src/gsl.mk	Thu Nov 17 08:23:05 2016 -0500
@@ -3,8 +3,8 @@
 
 PKG             := gsl
 $(PKG)_IGNORE   :=
-$(PKG)_VERSION  := 1.15
-$(PKG)_CHECKSUM := d914f84b39a5274b0a589d9b83a66f44cd17ca8e
+$(PKG)_VERSION  := 1.16
+$(PKG)_CHECKSUM := 210af9366485f149140973700d90dc93a4b6213e
 $(PKG)_SUBDIR   := $(PKG)-$($(PKG)_VERSION)
 $(PKG)_FILE     := $(PKG)-$($(PKG)_VERSION).tar.gz
 $(PKG)_URL      := http://ftp.gnu.org/gnu/$(PKG)/$($(PKG)_FILE)
diff -r 64063cd35eb2 -r 32483451ec70 src/of-gsl.mk
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/src/of-gsl.mk	Thu Nov 17 08:23:05 2016 -0500
@@ -0,0 +1,22 @@
+# This file is part of MXE.
+# See index.html for further information.
+
+PKG             := of-gsl
+$(PKG)_IGNORE   :=
+$(PKG)_VERSION  := 2.0.0
+$(PKG)_CHECKSUM := # No checksum
+$(PKG)_REMOTE_SUBDIR := 
+$(PKG)_SUBDIR   := gsl-$($(PKG)_VERSION)
+$(PKG)_FILE     := gsl-$($(PKG)_VERSION).tar.gz
+$(PKG)_URL      := '$(OCTAVE_FORGE_BASE_URL)/$($(PKG)_FILE)/download'
+$(PKG)_DEPS     := gsl
+
+define $(PKG)_UPDATE
+    $(WGET) -q -O- 'http://$(SOURCEFORGE_MIRROR)/projects/octave/files/Octave%20Forge%20Packages/Individual%20Package%20Releases/' | \
+    $(SED) -n 's,.*title="gsl-\([0-9][^"]*\).tar.gz".*,\1,p' | \
+    head -1
+endef
+
+define $(PKG)_BUILD
+    $(OCTAVE_FORGE_PKG_BUILD)
+endef