# HG changeset patch
# User Colin Macdonald <cbm@m.fsf.org>
# Date 1454698583 28800
#      Fri Feb 05 10:56:23 2016 -0800
# Node ID 6fddb1036a7179de9b56d93060df76e99d69e63b
# Parent  1bed4f4851b64b8ccbec8fa542e91491feb2f8e4
License metainfo.xml as GNU All Permissive

diff -r 1bed4f4851b6 -r 6fddb1036a71 octave-image.metainfo.xml
--- a/octave-image.metainfo.xml	Fri Jan 29 22:51:07 2016 -0800
+++ b/octave-image.metainfo.xml	Fri Feb 05 10:56:23 2016 -0800
@@ -6,8 +6,6 @@
 are permitted in any medium without royalty provided the copyright
 notice and this notice are preserved.  This file is offered as-is,
 without any warranty.
-
-This file is also available, at your option, under the CC0 license.
 -->
 <component type="addon">
   <id>octave-image</id>
@@ -36,6 +34,5 @@
   <project_license>GPL-3.0+</project_license>
   <developer_name>Octave-Forge Community</developer_name>
   <update_contact>octave-maintainers@gnu.org</update_contact>
-  <metadata_license>CC0-1.0</metadata_license>
-  <!-- Later: <metadata_license>All-Permissive</metadata_license>-->
+  <metadata_license>FSFAP</metadata_license>
 </component>
# HG changeset patch
# User Colin Macdonald <cbm@m.fsf.org>
# Date 1454136599 28800
#      Fri Jan 29 22:49:59 2016 -0800
# Node ID 9e9604f9edab49f441ed341c6bb8fe268c918cf1
# Parent  70d1412f9404097e9386b6e52640fd2090cc8fc3
Add keywords and clean up licensing of metainfo.xml

diff -r 70d1412f9404 -r 9e9604f9edab octave-image.metainfo.xml
--- a/octave-image.metainfo.xml	Mon Jan 18 12:06:49 2016 -0800
+++ b/octave-image.metainfo.xml	Fri Jan 29 22:49:59 2016 -0800
@@ -1,12 +1,41 @@
 <?xml version="1.0" encoding="UTF-8"?>
+<!--
+Copyright 2016 Colin B. Macdonald
+
+Copying and distribution of this file, with or without modification,
+are permitted in any medium without royalty provided the copyright
+notice and this notice are preserved.  This file is offered as-is,
+without any warranty.
+
+This file is also available, at your option, under the CC0 license.
+-->
 <component type="addon">
   <id>octave-image</id>
   <extends>www.octave.org-octave.desktop</extends>
   <name>Image</name>
   <summary>Image processing, feature extraction, transformations, morphological operations, filters, and more</summary>
+  <description>
+    <p>Provides functions for processing images, such as feature
+    extraction, image statistics, spatial and geometric
+    transformations, morphological operations, linear filtering, and
+    much more.</p>
+  </description>
+    <keywords>
+    <keyword>image processing</keyword>
+    <keyword>feature extraction</keyword>
+    <keyword>spatial transform</keyword>
+    <keyword>geometric transform</keyword>
+    <keyword>morphological operation</keyword>
+    <keyword>linear filter</keyword>
+    <keyword>convolution</keyword>
+    <keyword>bwregion</keyword>
+    <keyword>regionprops</keyword>
+  </keywords>
   <url type="homepage">http://octave.sourceforge.net/image</url>
   <url type="bugtracker">https://savannah.gnu.org/bugs/?func=additem&amp;group=octave</url>
+  <project_license>GPL-3.0+</project_license>
+  <developer_name>Octave-Forge Community</developer_name>
+  <update_contact>octave-maintainers@gnu.org</update_contact>
   <metadata_license>CC0-1.0</metadata_license>
-  <project_license>GPL-3.0+</project_license>
-  <update_contact>octave-maintainers_AT_gnu.org</update_contact>
+  <!-- Later: <metadata_license>All-Permissive</metadata_license>-->
 </component>
# HG changeset patch
# User Colin Macdonald <cbm@m.fsf.org>
# Date 1453147609 28800
#      Mon Jan 18 12:06:49 2016 -0800
# Node ID 70d1412f9404097e9386b6e52640fd2090cc8fc3
# Parent  8a7bba373a039757a5540e1cc33360ef6c141085
Add metainfo.xml

This should make the package appear as an Add-on in Gnome Software.

diff -r 8a7bba373a03 -r 70d1412f9404 octave-image.metainfo.xml
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/octave-image.metainfo.xml	Mon Jan 18 12:06:49 2016 -0800
@@ -0,0 +1,12 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<component type="addon">
+  <id>octave-image</id>
+  <extends>www.octave.org-octave.desktop</extends>
+  <name>Image</name>
+  <summary>Image processing, feature extraction, transformations, morphological operations, filters, and more</summary>
+  <url type="homepage">http://octave.sourceforge.net/image</url>
+  <url type="bugtracker">https://savannah.gnu.org/bugs/?func=additem&amp;group=octave</url>
+  <metadata_license>CC0-1.0</metadata_license>
+  <project_license>GPL-3.0+</project_license>
+  <update_contact>octave-maintainers_AT_gnu.org</update_contact>
+</component>